// command.cpp 

#include "command.h"

bool emdl=false;  // le modle est-il disponible ?
bool etxt=false;  // la texture-image est-elle disponible ?
bool etpl=false;  // la topologie est-elle disponible ?
bool epuv=false;  // la paramtrisation est-elle disponible ?
bool cdit=false;  // true quand on a dit "paramtrisation impossible"
bool mdlt=false;  // true quand on affiche le modle textur

void getChemin(char *chemin, DWORD taille) {  // pour obtenir le chemin
    char *c;                                  // de l'application sans son nom
    c = chemin + GetModuleFileName(NULL, chemin, taille);
    while(*c!='\\') c--;
    *c=0;                 // pour le '\0' final
}

void command(WPARAM wParam) {
    char texte[385];
    rfm=false;   // pour l'ventualit de refermer, c'est trop tard !
    if(wParam == IDM_AFFITXTU) {
        if(vuv || vtx) return;
        if(mdlt) {
            restaurecond(); 
            mdlt=false; 
            return;
        }
        sauvecond();
        condinit();
        if(!epuv) parametrise();
        itex=2;
        mdlt=true;
        return;
    }
    switch( wParam ) {
        case IDM_FILEOPEN:  // Fichier > Ouvrir
            openModel();
            return;
        case IDM_FILESAVE:  // Fichier > Sauver
            saveModel();
            return;
        case IDM_FILEEXIT:  // Fichier > Quitter
            SendMessage(hWnd, WM_CLOSE, 0, 0L);
            return;
        case IDM_AFFIAXES:  // Affichage > Axes
            vax = !vax;
            return;
        case IDM_AFFISOMM:  // Affichage > Sommets
            vsm = !vsm;
            return;
        case IDM_AFFIARET:  // Affichage > Artes
            var = !var;
            return;
        case IDM_AFFIFACS:  // Affichage > Faces
            vfa = !vfa;
            if(vfa) itex=itxf;
            else{itxf=itex; itex=0;}
            return;
        case IDM_AFFINORM:  // Affichage > Normales
            vnr = !vnr;
            return;
        case IDM_AFFIBORD:  // Affichage > Bordures
            vbr = !vbr;
            return;
        case IDM_AFFIFRON:  // Affichage > Frontire
            if(!epuv) parametrise();
            if(cdit) return;
            vfr = !vfr;
            return;
        case IDM_AFFIPLAN:  // Affichage > Plan (u,v)
            if(vtx || mdlt) return;
            if(cdit) return;
            if(!epuv) {parametrise(); if(!epuv) return;}
            if(vuv) {restaurecond(); arc=false;}
            vuv = !vuv;
            return;
        case IDM_AFFITEXT:  // Affichage > Texture
            if(vuv || mdlt) return;
            if(vtx) {restaurecond(); arc=false;}
            vtx = !vtx;
            return;
        case IDM_AFFITRAN:  // Affichage > Transparence
            trp=!trp;
            return;
        case IDM_AFFIANIM:  // Affichage > Animation
            ani=!ani;
            return;
        case IDM_AFFIINIT:  // Affichage > Conditions initiales
            condinit();
            return;
        case IDM_MODLSOMM:  // Modle > Sommet
            couperSommet();
            return;
        case IDM_MODLFACE:  // Modle > Face
            couperFace();
            return;
        case IDM_MODLARET:  // Modle > Arte
            couperArete();
            return;
        case IDM_MODLLOOP:  // Modle > Loop
            subdivLoop();
            return;
        case IDM_MODLSTAT:  // Modle > Composition
            char buf[16];
            strcpy(texte, "Le modle actuel comprend : \n\n - ");
            sprintf(buf, "%d", ns);
            strcat(texte, buf);
            strcat(texte, " sommets\n\n - "); 
            sprintf(buf, "%d", nf);
            strcat(texte, buf);
            strcat(texte, " faces\n\n - "); 
            sprintf(buf, "%d", na);
            strcat(texte, buf);
            strcat(texte, " artes"); 
            if(naf>0) {
                strcat(texte, "\n\n - "); 
                sprintf(buf, "%d", naf);
                strcat(texte, buf);
                strcat(texte, " artes de frontire"); 
            }
            else {
                strcat(texte, "\n\n - le modle est ferm"); 
                strcat(texte, "\n   il n'y a pas de frontire"); 
            }
            inform(texte);
            return;
        case IDM_TEXTIMGE:  // Texture > Image
            chargeTextureFile();
            return;
        case IDM_TEXTUNIE:  // Texture > Couleur unie
            CHOOSECOLOR cc;
            static COLORREF acrCustClr[16];
            ZeroMemory(&cc, sizeof(CHOOSECOLOR));
            cc.lStructSize = sizeof(CHOOSECOLOR);
            cc.hwndOwner = hWnd;
            cc.lpCustColors = NULL;
            cc.lpCustColors = (LPDWORD) acrCustClr;
            cc.rgbResult = textColor;
            cc.Flags = CC_FULLOPEN | CC_RGBINIT;
            if(ChooseColor(&cc)==TRUE) textColor = cc.rgbResult;
            chargeTextureProc();
            return;
        case IDM_HELPHELP:  // Aide > Aide
            strcpy(texte,"Pour une aide simple voir le guidage dans la barre d'tat.");
            strcat(texte,"\n\nEt pour voir l'aide complte cliquez sur : Aide en html");
            inform(texte);
            return;
        case IDM_HELPAIDE:  // Aide > En html
            getChemin(texte, MAX_PATH);         // pour lancer l'aide il faut se
            strcat(texte, "\\");                // rfrer au rpertoire de l'application
            strcat(texte,"aide.html");          // quelque soit celui du modle lu !
            ShellExecute(NULL, NULL, texte, 0, 0, SW_SHOWNORMAL);
            return;
        case IDM_HELPAPRO:  // Aide > A propos
            inform("Copyright  PGL10\n\npgl10@yahoo.com");
            return;
    }
}