// loop.cpp

#include "loop.h"

int    *lv, *i1, *i2, *is, sv, nfi, nba;
double *xa, *ya, *za;

void svs(int j, int k) {  // on mmorise les sommets voisins
   if(sv == 0) {
      sv = 2;
      lv = new int[sv];
      lv[0] = j;
      lv[1] = k;
   }
   else {
      reallocint(&lv, sv, sv+2);
      sv = sv+2;
      lv[sv-2] = j;
      lv[sv-1] = k;
   }
   return;
}

int ivs() {     // combien de sommets voisins ont t trouvs une seule fois ?
   int ij, n1;
   n1 = 0;
   for(int i=0; i<sv; i++) {
      ij = 0;
      for(int j=0; j<sv; j++) if(lv[i] == lv[j]) ij=ij+1;
      if(ij == 1) {
         xint(&lv[n1], &lv[i]);   // les sommets voisins de frontire ne sont 
         n1= n1+1;                // trouvs qu'une fois, on les met au dbut.
      }
   }
   return n1;
}

void la(int j, int k) {  // on mmorise les artes une seule fois chacune
   int j1, j2;                     
   if(j<k) {j1=j; j2=k;}
   else    {j1=k; j2=j;}  // j2 > j1 
   if(nba == 0) {
      nba = 1;
      i1 = new int;
      i2 = new int;
      is = new int;
      i1[0]=j1; 
      i2[0]=j2;
      is[0]=-1;
   }
   else {
      for(int i=0; i<nba; i++) if((i1[i]==j1)&&(i2[i]==j2)) return;
      reallocint(&i1, nba, nba+1);
      reallocint(&i2, nba, nba+1);
      reallocint(&is, nba, nba+1);
      nba = nba + 1;
      i1[nba-1]=j1;    // numro de sommet le plus petit
      i2[nba-1]=j2;    // numro de sommet le plus grand      
      is[nba-1]=-1;    // pour le numro du nouveau sommet associ    
   }
   return;
}

int ia(int j, int k) {  // de quelle arte s'agit-il ?
   int j1, j2;                     
   if(j<k) {j1=j; j2=k;}
   else    {j1=k; j2=j;} 
   for(int i=0; i<nba; i++) if((i1[i]==j1)&&(i2[i]==j2)) return i;
   erreur("Modle impossible");
   return 0;
}

bool ja(int j, int k, int i) {  // l'arte j,k est-elle la i-ime ?
   int j1, j2;                     
   if(j<k) {j1=j; j2=k;}
   else    {j1=k; j2=j;} 
   if((i1[i]==j1)&&(i2[i]==j2)) return TRUE;
   else return FALSE;
}

int mid(int i) {  // pour crer le nouveau sommet associ  l'arte i
   int s3[2], n3;
   n3=0;
   for(int j=0; j<nfi; j++) {
      if(ja(ifa[j], jfa[j], i)) {s3[n3]=kfa[j]; n3=n3+1; if(n3==2)break;}
      if(ja(jfa[j], kfa[j], i)) {s3[n3]=ifa[j]; n3=n3+1; if(n3==2)break;}
      if(ja(kfa[j], ifa[j], i)) {s3[n3]=jfa[j]; n3=n3+1; if(n3==2)break;}
   }
   if(n3 == 1) {
      xs[ns] = (xa[i1[i]] + xa[i2[i]])/2.0f;
      ys[ns] = (ya[i1[i]] + ya[i2[i]])/2.0f; // arte de frontire
      zs[ns] = (za[i1[i]] + za[i2[i]])/2.0f;
   }
   else {  // arte intrieure
      xs[ns] = (xa[s3[0]]+(xa[i1[i]]+xa[i2[i]])*3.0f+xa[s3[1]])/8.0f;
      ys[ns] = (ya[s3[0]]+(ya[i1[i]]+ya[i2[i]])*3.0f+ya[s3[1]])/8.0f;
      zs[ns] = (za[s3[0]]+(za[i1[i]]+za[i2[i]])*3.0f+za[s3[1]])/8.0f;
   }
   is[i] = ns;
   ns = ns+1;
   return (ns-1);
}

void subdivLoop() {  // pour faire une itration de subdivision selon Charles Loop
   double uk, ba, ca, pi=3.1415926535897932384626;
   int i, kv, nn, nnf, ar, ifn, jfn, kfn;
   xa = new double[ns];
   ya = new double[ns];
   za = new double[ns];
   for(i=0; i<ns; i++) {
      xa[i] = xs[i];
      ya[i] = ys[i]; // on copie les sommets actuels
      za[i] = zs[i];
   }
   for(i=0; i<ns; i++) {  // on replace chaque sommet actuel
      sv=0;
      for(int j=0; j<nf; j++) {
         if(ifa[j] == i) svs(jfa[j], kfa[j]);
         if(jfa[j] == i) svs(kfa[j], ifa[j]); // on range les sommets voisins du sommet i
         if(kfa[j] == i) svs(ifa[j], jfa[j]);
      }
      if(sv == 0) continue;  // sommet i isol : on le laisse inchang
      if(ivs() == 2) {        // un sommet i de frontire a 2 voisins trouvs 1 fois
         xs[i] = (xa[lv[0]] + 6.0*xa[i] + xa[lv[1]])/8.0;
         ys[i] = (ya[lv[0]] + 6.0*ya[i] + ya[lv[1]])/8.0;
         zs[i] = (za[lv[0]] + 6.0*za[i] + za[lv[1]])/8.0;
      }
      else {               // le sommet i est intrieur
         kv = sv/2;        // arit(i)
         uk = 1.0/((double) kv);
         ba = (3.0/8.0 + (1.0/4.0)*cos(2.0*pi*uk)); 
         ba = uk*(5.0/8.0 - ba*ba);
         xs[i] = ys[i] = zs[i] = 0.0;
         for (int j=0; j<sv; j++) {
            xs[i] = xs[i] + xa[lv[j]];  // dans cette liste 
            ys[i] = ys[i] + ya[lv[j]];  // les sommets voisins
            zs[i] = zs[i] + za[lv[j]];  // sont additionns 2 fois.
         }
         ca = 1.0 - ((double) kv)*ba;
         xs[i] = ba*xs[i]/2.0 + ca*xa[i];
         ys[i] = ba*ys[i]/2.0 + ca*ya[i];
         zs[i] = ba*zs[i]/2.0 + ca*za[i];
         delete [] lv;
      }
   }
   nba = 0;
   for(i=0; i<nf; i++) {  // on cre la liste des artes
      la(ifa[i], jfa[i]);
      la(jfa[i], kfa[i]);
      la(kfa[i], ifa[i]);
   }
   nn = ns + 3*nba; 
   reallocdouble(&xs, ns, nn);
   reallocdouble(&ys, ns, nn);
   reallocdouble(&zs, ns, nn);
   nnf = 4*nf;
   reallocint(&ifa, nf, nnf);
   reallocint(&jfa, nf, nnf);
   reallocint(&kfa, nf, nnf);
   nfi = nf;
   for(i=0; i<nfi; i++) {  
      ar = ia(jfa[i], kfa[i]);
      if(is[ar] != -1) ifn = is[ar];
      else ifn = mid(ar);
      ar = ia(kfa[i], ifa[i]);        // si le nouveau sommet relatif
      if(is[ar] != -1) jfn = is[ar];  //  chaque arte est dj cr
      else jfn = mid(ar);             // on l'utilise, sinon on le cre.
      ar = ia(ifa[i], jfa[i]);
      if(is[ar] != -1) kfn = is[ar];
      else kfn = mid(ar);
      nf=nf+3;                  // on redfinit les nouvelles faces
      ifa[nf-3]=ifa[i]; jfa[nf-3]=kfn; kfa[nf-3]=jfn;
      ifa[nf-2]=jfa[i]; jfa[nf-2]=ifn; kfa[nf-2]=kfn;
      ifa[nf-1]=kfa[i]; jfa[nf-1]=jfn; kfa[nf-1]=ifn;
      ifa[i]=ifn; jfa[i]=jfn; kfa[i]=kfn; 
   }
   delete [] xa;
   delete [] ya;
   delete [] za;
   delete [] i1;
   delete [] i2;
   delete [] is;
   cdit=false;
   if(epuv==false) {
       etpl=false;
       topologie();
       return;
   }
   etpl=false;
   epuv=false;
   parametrise();
}
