// main.cpp

#include "main.h"

LRESULT CALLBACK WndProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam);
LRESULT CALLBACK GLWndProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam);

char  monprojet[] = "Affimoff 0.35";
char  maclasse[] = "MaClasse";
HWND  hWnd, hSb;
HWND  g_hGLChildWnd;
bool  g_active=true;		    
HDC   g_hdc;		
HGLRC g_hrc;	
int   width, height;

HWND CreateGLWnd(HWND hParent,TCHAR *classname);
void DrawGL(void);
bool StartGL(HWND hWnd);
bool StopGL(HWND hWnd);
       
int WINAPI WinMain(HINSTANCE hInst, HINSTANCE hPrev, LPSTR pStr, int nCmd) {
    MSG        msg;
    WNDCLASSEX wcx={0};
    HMENU      menu; 

    wcx.cbSize=sizeof(wcx);
    wcx.lpfnWndProc=WndProc;
    wcx.hInstance=hInst;
    wcx.hIcon=(HICON)LoadImage(0, IDI_APPLICATION, IMAGE_ICON, 0, 0, LR_SHARED);
    wcx.hCursor=(HCURSOR)LoadImage(0, IDC_ARROW, IMAGE_CURSOR, 0, 0, LR_SHARED);
    wcx.hbrBackground=(HBRUSH)(COLOR_BTNFACE+1);
    wcx.lpszClassName=_T(maclasse);
    if (!RegisterClassEx(&wcx)) {
        MessageBox(0, _T("Erreur"), _T("Registration failed."), MB_OK | MB_ICONERROR);
        return 0;
    }
    width = 640;
    height= 640;
    hWnd=CreateWindowEx(0, _T(maclasse), _T(monprojet),
                        WS_OVERLAPPEDWINDOW | WS_CLIPCHILDREN,
                        CW_USEDEFAULT,
                        CW_USEDEFAULT,
                        width,
                        height,
                        HWND_DESKTOP,
                        0, hInst, 0);
    if (!hWnd) {
        MessageBox(0, _T("Erreur"), _T("Creation failed."), MB_OK | MB_ICONERROR);
        return 0;
    }
    ShowWindow(hWnd, SW_SHOW);
    UpdateWindow(hWnd);

    menu = LoadMenu(hInst, MAKEINTRESOURCE(ID_MENU));
    SetMenu(hWnd, menu);

    openModel();
    initOpenGL();

    while (TRUE) {
        if (PeekMessage(&msg, 0, 0, 0, PM_REMOVE)>0) {
            if (msg.message==WM_QUIT) return (int)msg.wParam;
            else {
                TranslateMessage(&msg);
                DispatchMessage(&msg);
            }
        }
        else
            if (g_active==TRUE) DrawGL();
            else WaitMessage();
    }
    return 0;
}

int OnCreate(HWND hWnd, CREATESTRUCT *cs) {
    g_hGLChildWnd=CreateGLWnd(hWnd, _T("gl_child_wnd"));
    return 0;
}

void OnSize(HWND hWnd, int cx, int cy, UINT uFlags) {
    MoveWindow(g_hGLChildWnd, 0, 0, cx, cy, 1);
    if (uFlags==SIZE_MINIMIZED || uFlags==SIZE_MAXHIDE) g_active=FALSE;
    else g_active=TRUE;
}

LRESULT CALLBACK WndProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam) {
    RECT sbRect;
    UINT sbheight;
    switch (uMsg) {
        case WM_CREATE:
            OnCreate(hWnd,(CREATESTRUCT*)lParam);
            InitCommonControls();
            hSb = CreateStatusWindow(WS_CHILD | WS_VISIBLE, "Ici votre guidage ...", hWnd, (UINT)-1);
            return 0;
        case WM_DESTROY:
            deleteModel();
            PostQuitMessage(0);
            return 0;
        case WM_SIZE:
            width = LOWORD(lParam);
            height = HIWORD(lParam); 
            GetWindowRect(hSb, &sbRect);
            sbheight = sbRect.bottom - sbRect.top;   // hauteur de la barre d'tat
            MoveWindow(hSb, 0, height-sbheight, width, sbheight, TRUE);
//          OnSize(hWnd,LOWORD(lParam),HIWORD(lParam)-sbheight,(UINT)wParam);
            OnSize(hWnd,LOWORD(lParam),HIWORD(lParam),(UINT)wParam);
            return 0;
        case WM_KEYDOWN:
            switch ( wParam ) {			
                case VK_ESCAPE:
                    PostQuitMessage(0);
                    return 0;
            }
            return 0;
        case WM_COMMAND:
            command(wParam);
            return 0;
        case WM_MENUSELECT:
            if(lParam == (LONG)GetMenu(hWnd)) sbmenu0(LOWORD(wParam));
            else sbmenu1(LOWORD(wParam));
            return 0;
        case WM_EXITMENULOOP:
            guidage("Ici votre guidage ...");
            return 0;
        default:
            return DefWindowProc(hWnd,uMsg,wParam,lParam);
    }
}

HWND CreateGLWnd(HWND hParent,TCHAR *classname) {
    /* create the child 'control' */
    WNDCLASSEX wcx={0};
    wcx.cbSize= sizeof(WNDCLASSEX);              
    wcx.style= CS_HREDRAW|CS_VREDRAW|CS_OWNDC;  
    wcx.lpfnWndProc=GLWndProc;                         
    wcx.hInstance=GetModuleHandle(0);     
    wcx.hCursor=(HCURSOR)LoadImage(0,IDC_ARROW,IMAGE_CURSOR,0,0,LR_SHARED);              
    wcx.lpszClassName=classname;                       
    /*register the wnd class; fail if class not previously registered and this attempt to register fails*/
    if (!RegisterClassEx(&wcx) && !GetClassInfoEx(GetModuleHandle(0),classname,&wcx)) return 0;
    return CreateWindowEx(WS_EX_CLIENTEDGE,classname,0,           
                          WS_CHILD|WS_VISIBLE,
                          0,0,100,100, 
                          hParent,(HMENU)IDC_OPENGL_CHILD_CONTROL,
                          GetModuleHandle(0),0);
}

bool StartGL(HWND hWnd) {
    int format;
    PIXELFORMATDESCRIPTOR pfd={0};
    g_hdc=GetDC(hWnd);
    if (g_hdc) {
        pfd.nSize      = sizeof( pfd );
        pfd.nVersion   = 1;
        pfd.dwFlags    = PFD_DRAW_TO_WINDOW|PFD_SUPPORT_OPENGL|PFD_DOUBLEBUFFER;
        pfd.iPixelType = PFD_TYPE_RGBA;
        pfd.cColorBits = 24;
        pfd.cDepthBits = 16;
        pfd.iLayerType = PFD_MAIN_PLANE;
  
        if ((format=ChoosePixelFormat(g_hdc,&pfd))<1) {
            MessageBox(0,_T("GL Erreur"),_T("ChoosePixelFormat failed."),MB_OK|MB_ICONERROR);
            return FALSE;
        }
        if (!SetPixelFormat(g_hdc,format,&pfd)) {
            MessageBox(0,_T("GL Erreur"),_T("SetPixelFormat failed."),MB_OK|MB_ICONERROR);
            return FALSE;
        }
        if ((g_hrc=wglCreateContext(g_hdc))==NULL) {
            MessageBox(0,_T("GL Erreur"),_T("wglCreateContext failed."),MB_OK|MB_ICONERROR);
            return FALSE;
        }
        if (!wglMakeCurrent(g_hdc,g_hrc)) {
            MessageBox(0,_T("GL Erreur"),_T("wglMakeCurrent failed."),MB_OK|MB_ICONERROR);
            return FALSE;
        }
        /*set up basics*/
        glShadeModel(GL_SMOOTH);							
        glClearColor(0.15f, 0.15f, 0.15f, 0.5f);
        glClearDepth(1.0f);									
        glEnable(GL_DEPTH_TEST);							
        glDepthFunc(GL_LEQUAL);								
        glHint(GL_PERSPECTIVE_CORRECTION_HINT,GL_NICEST);
        return TRUE;
    }
    MessageBox(0,_T("Erreur"),_T("GetDC failed."),MB_OK|MB_ICONERROR);
    return FALSE;
}

bool StopGL(HWND hWnd) {
    if (g_hdc) {
        wglMakeCurrent(0,0);
        wglDeleteContext(g_hrc);
        ReleaseDC(g_hGLChildWnd,g_hdc);
        return TRUE;
    }
    return FALSE;
}

void DrawGL(void) {
    displayGL();
    SwapBuffers(g_hdc);
}

LRESULT CALLBACK GLWndProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam) {
    switch (uMsg) {
        case WM_CREATE:
            StartGL(hWnd);
            return 0;
        case WM_DESTROY:
            StopGL(hWnd);
            return 0;
        case WM_PAINT:
            DrawGL();
            ValidateRect(hWnd,0);
            return 0;
        case WM_SIZE: {
            WORD cx,cy;
            cx=LOWORD(lParam);
            cy=HIWORD(lParam);
            glViewport(0,0,cx,cy);
            glMatrixMode(GL_PROJECTION);
            glLoadIdentity();
            gluPerspective(45.0,(GLdouble)cx/(GLdouble)cy,0.1,100.0);
            glMatrixMode(GL_MODELVIEW);
            glLoadIdentity();
            return 0;
        }
        default:
        return DefWindowProc(hWnd,uMsg,wParam,lParam);
    }
}
