// model.cpp

#include "model.h"

int ns=0, nf=0;         //  nombres de sommets et de faces
int na=0, nab=0, naf=0; //  nombres d'artes et d'artes de bordure et de frontire
double *xs, *ys, *zs;   //  coordonnes de chaque sommet
int *ifa, *jfa, *kfa;   //  numros des sommets de chaque triangle
double dc, xc, yc, zc;  //  taille et centre du modle
char model[MAX_PATH];   //  nom du modle : fichier.off
int isel, csm=0, car=0, cfa=0, saf;  // isel : n slectionn, csm : 1 quand on dcoupe un sommet ...
int nv;                 //  nombre de nouveaux sommets pour ouvrirSommet() et ouvrirArete()
int i1=0, s1, s2;       //  arte n 1, sommet n 1 et 2 pour ouvrirArete()

int premline(char **buffer, char *line, int nkli) {    
    // on veut extraire de buffer la premire ligne : line
    // line doit tre au moins dimensionne  : nkli+1 pour avoir le : '\0' final.          
    char *pointeur;
    if((pointeur=strchr(*buffer,'\n'))==NULL) {
        if(nkli<(int)strlen(*buffer)) {    // line est trop petite pour recevoir
            *line='\0';                    // la ligne unique de buffer.
            return 3;                      // line est vide, buffer est conserv.
        }
        strcpy(line,*buffer);        // line reoit la ligne unique de buffer.
        return 1;                    // buffer est conserv.
    }
    *pointeur='\0';
    if(nkli<(int)strlen(*buffer)) {
        *pointeur='\n';              // line est trop petite pour recevoir 
        *line='\0';                  // la premire ligne de buffer.
        return 2;                    // line est vide, buffer est conserv.
    }                             
    strcpy(line,*buffer);           // line reoit la premire ligne de buffer.
    *pointeur='\n';                 // on rtablit le '\n' ( mais ce n'est plus ncessaire ! )
    *buffer = pointeur+1;           // on "enlve" la premire ligne.
    return 0;
}

int premligne(char **buffer, char *line, int nkli) {
    bool continuer;
    int  i,ret;      // pour ne pas utiliser les commentaires et les lignes blanches ou vides
    continuer=true;
    while(continuer) {
        ret=premline(buffer, line, nkli); 
        if(ret != 0) return ret;           // si il y a une erreur dans premline : on la transmet.
        if(line[0] == '*') continue;       // si ligne de commentaires : on va prendre la suivante.
        if(line[0] == '#') continue;
        for(i=0; i<(int)strlen(line)-1; i++) if(line[i] != ' ') {
            continuer=false;
            break;                           // si ligne toute blanche : on va prendre la suivante.
        }
   }
   return 0;
}

void deleteModel() {   // libration de la mmoire du modle prcdent
    delete [] xs; delete [] ys; delete [] zs; 
    delete [] ifa; delete [] jfa; delete [] kfa;
    if(etpl) {delete [] iar; delete [] jar; delete [] fa1; delete [] fa2;}
    if(epuv) {delete [] us; delete [] vs;}
    ns = nf = na = nab = naf = 0;
    emdl = etpl = epuv = cdit = false;
}

void openModel() {
    OPENFILENAME ofn;
    char szFile[MAX_PATH]={0};
    HANDLE hf;
    DWORD FileSize,nbCharFile;
    char *buffer, *pointeur;
    char *fichier, line[151];
    int i, fa, nscan, nbs, lfa;
    bool bad;
    bad = false;  // pour la cas o le modle serait erron    
    ZeroMemory(&ofn, sizeof(OPENFILENAME));
    ofn.lStructSize = sizeof(OPENFILENAME);
    ofn.hwndOwner = hWnd;
    ofn.lpstrFile = szFile;
    ofn.nMaxFile = MAX_PATH;
    ofn.lpstrTitle="Choisissez le fichier du modle  ouvrir.";
    ofn.lpstrFilter = "Fichier off (*.off)\0*.off\0Tout fichier (*.*)\0*.*\0\0";
    ofn.nFilterIndex = 1;
    ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
    if(GetOpenFileName(&ofn)==false) return;
    else {
        if(emdl) deleteModel();
        strcpy(line, monprojet);
        strcat(line," - modle affich : ");
        hf = CreateFile(szFile, GENERIC_READ, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
        buffer = (char *)szFile;       // nom du fichier du modle avec le chemin complet 
        strcpy(model, buffer);
        while((pointeur=strchr(buffer,'\\')) != NULL) strcpy(buffer,pointeur+1); 
        strcat(line,buffer);           // on met le nom du modle ( sans le chemin )
        SetWindowText(hWnd,line);      // dans la barre de titre.
        FileSize = GetFileSize(hf, NULL);
        fichier = (char *)LocalAlloc(LMEM_FIXED, FileSize+1);
        ReadFile(hf, fichier, FileSize, &nbCharFile, NULL) ;  // copie dans fichier du fichier du modle
        fichier[FileSize] = '\0'; 
        premligne(&fichier,line,150);
        nscan=sscanf(line, "%s", &line);
        if(strcmp(line,"OFF") || nscan<1) bad=true;  // contrle premire ligne
        premligne(&fichier,line,150);
        nscan=sscanf(line, "%d%d%d", &ns, &nf, &na);
        if(nscan<2 || ns<1 || nf<1) bad=true;        // contrle deuxime ligne
        xs = new double[ns];     
        ys = new double[ns];     
        zs = new double[ns];     
        ifa = new int[nf];
        jfa = new int[nf];
        kfa = new int[nf];
        emdl = true;
        for(i=0; i<ns; i++) {
            premligne(&fichier,line,150);
            nscan=sscanf(line,"%lf%lf%lf",&xs[i],&ys[i],&zs[i]);
            if(nscan<3) bad=true;      // contrle ligne d'un sommet
        }
        fa=nf;
        for(i=0; i<fa; i++) {
            premligne(&fichier,line,150);
            nscan=sscanf(line,"%d%d%d%d%d",&nbs,&ifa[i],&jfa[i],&kfa[i],&lfa);
            if(nscan<4) bad=true;
            if(nbs<3)   bad=true;    // contrle ligne d'une face
            if(nbs>4)   bad=true;       
            if(nbs==4)  {  // on va trianguler ce quadrilatre => + 1 sommet et + 3 faces
                reallocdouble(&xs, ns, ns+1);
                reallocdouble(&ys, ns, ns+1);
                reallocdouble(&zs, ns, ns+1);
                ns=ns+1;
                reallocint(&ifa, nf, nf+3);
                reallocint(&jfa, nf, nf+3);
                reallocint(&kfa, nf, nf+3);
                nf=nf+3;
                xs[ns-1] = (xs[ifa[i]]+xs[jfa[i]]+xs[kfa[i]]+xs[lfa])/4.0;
                ys[ns-1] = (ys[ifa[i]]+ys[jfa[i]]+ys[kfa[i]]+ys[lfa])/4.0;
                zs[ns-1] = (zs[ifa[i]]+zs[jfa[i]]+zs[kfa[i]]+zs[lfa])/4.0;
                ifa[nf-3] = jfa[i];
                jfa[nf-3] = kfa[i];
                kfa[nf-3] = ns-1;
                ifa[nf-2] = kfa[i];
                jfa[nf-2] = lfa;
                kfa[nf-2] = ns-1;
                ifa[nf-1] = lfa;
                jfa[nf-1] = ifa[i];
                kfa[nf-1] = ns-1;
                kfa[i]=ns-1;         
            }
        }
        LocalFree(fichier);
        CloseHandle(hf);
        xc=0.0;
        yc=0.0;
        zc=0.0;       
        for(i=0;i<ns;i++) {
           xc=xc+xs[i];
           yc=yc+ys[i];
           zc=zc+zs[i];
        }
        xc=xc/(double)ns;
        yc=yc/(double)ns;    // centre du modle
        zc=zc/(double)ns;
        dc=0.0;
        for(i=0;i<ns;i++) {  // cube contentant tout le modle
           if(fabs(xs[i]-xc)>dc) dc=fabs(xs[i]-xc);                 
           if(fabs(ys[i]-yc)>dc) dc=fabs(ys[i]-yc);                 
           if(fabs(zs[i]-zc)>dc) dc=fabs(zs[i]-zc);                 
        }
    }
    if(bad) quitter("Fichier modle erron");
    condinit();
    etpl=false;
    epuv=false;
    cdit=false;
    topologie();
}

double xg(int i) {
    return zoom*(xs[i]-xc)/dc;
}

double yg(int i) {
    return zoom*(ys[i]-yc)/dc;
}

double zg(int i) {
    return zoom*(zs[i]-zc)/dc;
}

void saveModel() {
    FILE *fp;
    int i;
    char *pc1, *pc2, line[151];
    model[strlen(model)-4]='\0';
    strcat(model,"_n.off");
    fp = fopen(model, "w" );
    fprintf(fp,"%s\n","OFF");
    fprintf(fp," %d  %d  0\n", ns, nf); 
    for(i=0; i<ns; i++) fprintf(fp,"  %lf  %lf  %lf\n", xs[i], ys[i], zs[i]);
    for(i=0; i<nf; i++) fprintf(fp,"  3  %d  %d  %d\n", ifa[i], jfa[i], kfa[i]);
    fclose(fp);
    strcpy(line, monprojet);
    strcat(line," - modle affich : ");
    pc1=model;
    while((pc1=strchr(pc1,'\\')) != NULL) {pc2=pc1; pc1=pc1+1;} 
    strcat(line,pc2+1);
    SetWindowText(hWnd,line);
    strcpy(line,"Le nouveau modle : ");
    strcat(line,pc2+1);
    strcat(line," est archiv.");
    inform(line);
}

void newModel() {  // pour refaire la topologie quand le modle est modifi
    if(etpl) {delete [] iar; delete [] jar; delete [] fa1; delete [] fa2;}
    if(epuv) {delete [] us; delete [] vs;}
    na = nab = naf = 0;
    etpl = epuv = cdit = false;
    topologie();
}

void ouvrirSommet(int is) {
    int i, j, n;
    // on va compter le nombre de faces qui utilisent le sommet is
    n = 0;
    for(i=0; i<nf; i++) {
        if(ifa[i]==is) n=n+1;
        if(jfa[i]==is) n=n+1;
        if(kfa[i]==is) n=n+1;
    }
    if(n<2) {nv=0; couperSommet(); return;}
    // il y aura donc (n-1) nouveaux sommets
    reallocdouble(&xs, ns, ns+n-1);
    reallocdouble(&ys, ns, ns+n-1);
    reallocdouble(&zs, ns, ns+n-1);
    j=-1;
    for(i=0; i<nf; i++) {  // on attribue les nouveaux sommets
        if(ifa[i]==is) {
            if(j>=0) {
                xs[ns+j]=xs[is]; ys[ns+j]=ys[is]; zs[ns+j]=zs[is];
                ifa[i]=ns+j;
            }
            j=j+1;
        }
        if(jfa[i]==is) {
            if(j>=0) {
                xs[ns+j]=xs[is]; ys[ns+j]=ys[is]; zs[ns+j]=zs[is];
                jfa[i]=ns+j;
            }
            j=j+1;
        }
        if(kfa[i]==is) {
            if(j>=0) {
                xs[ns+j]=xs[is]; ys[ns+j]=ys[is]; zs[ns+j]=zs[is];
                kfa[i]=ns+j;
            }
            j=j+1;
        }
    }
    nv=n-1;
    ns=ns+nv;
    sel=false;
    newModel();
    voirBords();
    couperSommet();
}

void ouvrirArete(int is) {
    int i, j, k, fi, n, fa;
    n=0;
    for(i=0; i<nab; i++) {
        if(iar[is]==iar[i]) {j=1; n=n+1;}
        if(iar[is]==jar[i]) {j=1; n=n+1;}
        if(jar[is]==iar[i]) {j=2; n=n+1;}
        if(jar[is]==jar[i]) {j=2; n=n+1;}
    }
    if(n>2) {  // l'arte is a 2 extrmits en bordure
        if(fa2[is]<0) { // si elle est dj en bordure
            nv=0;       // il n'y a rien  faire
            sel=false;
            couperArete();
            return;
        }
        reallocdouble(&xs, ns, ns+2);
        reallocdouble(&ys, ns, ns+2);  // 2 nouveaux sommets
        reallocdouble(&zs, ns, ns+2);
        ns=ns+2;
        s1=iar[is]; s2=jar[is];
        xs[ns-2]=xs[s2]; ys[ns-2]=ys[s2]; zs[ns-2]=zs[s2];
        xs[ns-1]=xs[s1]; ys[ns-1]=ys[s1]; zs[ns-1]=zs[s1];
        k=-1;
        i=is;  // en plus de l'arte is la face de dpart a 2 autres artes
        fi=2;
        do {   // on explore en premier du ct de l'une d'elles ( l'arte k )
            if(fi==1) fa=fa1[i]; else fa=fa2[i];
            if(ifa[fa]==s1) ifa[fa]=ns-1; else if(ifa[fa]==s2) ifa[fa]=ns-2;
            if(jfa[fa]==s1) jfa[fa]=ns-1; else if(jfa[fa]==s2) jfa[fa]=ns-2;
            if(kfa[fa]==s1) kfa[fa]=ns-1; else if(kfa[fa]==s2) kfa[fa]=ns-2;
            for(j=0; j<na; j++) {
                if(j==i) continue;
                if((fa1[j]==fa||fa2[j]==fa)&&(iar[j]==s1||iar[j]==s2||jar[j]==s1||jar[j]==s2)) {
                    if(k<0) k=j;
                    i=j;
                    if(fa2[j]==fa) fi=1;
                    else fi=2;
                    if(fa2[j]<0) fi=0;
                    break;
                }
            }
        } while(fi!=0);
        i=is;
        fi=2;
        do {   // on explore en second du ct de l'autre
            if(fi==1) fa=fa1[i]; else fa=fa2[i];
            if(ifa[fa]==s1) ifa[fa]=ns-1; else if(ifa[fa]==s2) ifa[fa]=ns-2;
            if(jfa[fa]==s1) jfa[fa]=ns-1; else if(jfa[fa]==s2) jfa[fa]=ns-2;
            if(kfa[fa]==s1) kfa[fa]=ns-1; else if(kfa[fa]==s2) kfa[fa]=ns-2;
            for(j=0; j<na; j++) {
                if(j==i) continue;
                if(j==k) continue;
                if((fa1[j]==fa||fa2[j]==fa)&&(iar[j]==s1||iar[j]==s2||jar[j]==s1||jar[j]==s2)) {
                    i=j;
                    if(fa2[j]==fa) fi=1;
                    else fi=2;
                    if(fa2[j]<0) fi=0;
                    break;
                }
            }
        } while(fi!=0);
        nv=2;
        sel=false;
        newModel();
        couperArete();
        return;
    }
    if(n==2) {          // l'arte is touche une bordure 
        reallocdouble(&xs, ns, ns+1);
        reallocdouble(&ys, ns, ns+1);  // nouveau sommet
        reallocdouble(&zs, ns, ns+1);
        ns=ns+1;
        if(j==1) s1=iar[is]; else s1=jar[is];
        xs[ns-1]=xs[s1]; ys[ns-1]=ys[s1]; zs[ns-1]=zs[s1];
        i=is;
        fi=2;                        // 1 ou 2 au choix : arbitrairement
        do {
            if(fi==1) fa=fa1[i]; else fa=fa2[i];     // la face suivante
            if(ifa[fa]==s1) ifa[fa]=ns-1;
            if(jfa[fa]==s1) jfa[fa]=ns-1;           // le nouveau sommet
            if(kfa[fa]==s1) kfa[fa]=ns-1;           // remplace l'ancien
            for(j=0; j<na; j++) {
                if(j==i) continue;
                if((fa1[j]==fa||fa2[j]==fa)&&(iar[j]==s1||jar[j]==s1)) {
                    i=j;                               // arte suivante
                    if(fa2[j]==fa) fi=1;              // sur son ct fi
                    else fi=2;                       // -> nouvelle face
                    if(fa2[j]<0) fi=0;
                    break;
                }
            }
        } while(fi!=0);
        nv=1;
        sel=false;
        newModel();
        couperArete();
        return;
    }
//  ici il faut aller chercher une 2-ime arte conscutive  la 1-re
    if(i1==0) {
        i1=is;     // la premire arte
        return;    // pour une autre arte
    }
    s1=-1;
    if(iar[i1]==iar[is]) s1=iar[is];
    if(jar[i1]==iar[is]) s1=iar[is];
    if(iar[i1]==jar[is]) s1=jar[is];
    if(jar[i1]==jar[is]) s1=jar[is];
    if(s1<0) {
        i1=0;       // si pas de sommet commun
        nv=0;
        sel=false; 
        couperArete(); 
        return;
    }
    reallocdouble(&xs, ns, ns+1);
    reallocdouble(&ys, ns, ns+1);  // nouveau sommet
    reallocdouble(&zs, ns, ns+1);
    ns=ns+1;
    xs[ns-1]=xs[s1]; ys[ns-1]=ys[s1]; zs[ns-1]=zs[s1];
    i=is;
    fi=2;
    do {
        if(fi==1) fa=fa1[i]; else fa=fa2[i];
        if(ifa[fa]==s1) ifa[fa]=ns-1;
        if(jfa[fa]==s1) jfa[fa]=ns-1;
        if(kfa[fa]==s1) kfa[fa]=ns-1;
        for(j=0; j<na; j++) {
            if(j==i) continue;
            if((fa1[j]==fa||fa2[j]==fa)&&(iar[j]==s1||jar[j]==s1)) {
                i=j;
                if(fa2[j]==fa) fi=1;
                else fi=2;
                if(fa2[j]<0) fi=0;
                break;
            }
        }
    } while(i!=i1);
    i1=0;
    nv=1;
    sel=false;
    newModel();
    voirBords();
    couperArete();
}

void ouvrirFace(int is) {  // suppression de la face is
    int i, iis, jis, kis;
    iis=ifa[is];
    jis=jfa[is];
    kis=kfa[is];
    nf=nf-1;
    for(i=is; i<nf; i++) {
        ifa[i]=ifa[i+1];
        jfa[i]=jfa[i+1];
        kfa[i]=kfa[i+1];
    }
    ifa[nf]=iis;
    jfa[nf]=jis;
    kfa[nf]=kis;
    sel=false;
    newModel();
    couperFace();
}

void fermerSommet(int is) {
    int i;
    ns=ns-nv;
    for(i=0; i<nf; i++) {
        if(ifa[i]>ns-1) ifa[i]=is;
        if(jfa[i]>ns-1) jfa[i]=is;
        if(kfa[i]>ns-1) kfa[i]=is;
    }
    newModel();
}

void fermerArete(int is) {
    int i;
    if(nv==0) return;
    for(i=0; i<nf; i++) {
        if(ifa[i]==ns-1) ifa[i]=s1;
        if(jfa[i]==ns-1) jfa[i]=s1;
        if(kfa[i]==ns-1) kfa[i]=s1;
    }
    if(nv==2) {
        for(i=0; i<nf; i++) {
            if(ifa[i]==ns-2) ifa[i]=s2;
            if(jfa[i]==ns-2) jfa[i]=s2;
            if(kfa[i]==ns-2) kfa[i]=s2;
        }
    }
    ns=ns-nv;
    newModel();
    return;
}

void fermerFace(int is) {
    nf=nf+1;
    newModel();
}

void decouper() {
    if(csm) ouvrirSommet(isel);
    if(car) ouvrirArete(isel);
    if(cfa) ouvrirFace(isel);
}

void refermer() {
    if(saf==1) fermerSommet(isel);
    if(saf==2) fermerArete(isel);
    if(saf==3) fermerFace(isel);
    voirBords();
}

void couperSommet() {
    static bool vsma, vnra;
    csm=1-csm;
    if(csm) {
        vsma=vsm;
        vnra=vnr;
        vnr=false;
        vsm=true;
        mnw=false;
        sel=true;
        saf=1;
    }
    else {
        vnr=vnra;
        vsm=vsma;
        sel=false;
    }
}

void couperArete() {
    static bool vara, vnra, vfra;
    car=1-car;
    if(car) {
        vara=var;
        vnra=vnr;
        vfra=vfr;
        var=true;
        vnr=false;
        vfr=true;
        mnw=false;
        sel=true;
        saf=2;
    }
    else {
        var=vara;
        vnr=vnra;
        vfr=vfra;
        sel=false;
    }
}

void couperFace() {
    static bool vara, vnra, vfaa;
    cfa=1-cfa;
    if(cfa) {
        vara=var;
        vnra=vnr;
        vfaa=vfa;
        var=true;
        vnr=false;
        vfa=true;
        mnw=false;
        sel=true;
        saf=3;
    }
    else {
        var=vara;
        vnr=vnra;
        vfa=vfaa;
        sel=false;
    }
}
