// opengl.cpp

#include "opengl.h"

// conditions actuelles de l'affichage 
double dist=3.0, zoom=1.0, xold, yold, anglex=0.0, angley=0.0, anglez=0.0, dx=0.0, dy=0.0;
bool mnw=true, ani=false, trp=false, vax=false, vsm=false, var=false, vfa=true, vnr=false, vbr=false, vfr=false, vuv=false, vtx=false;
int itex=1, itxf=1;  // itex : texture actuelle, itxf : archive de itex ( 1 ou 2 ) quand on met itex  0
// archive des conditions d'affichage quand on passe  l'affichage de la texture image 
double distx, zoomx, xoldx, yoldx, anglexx, angleyx, anglezx, dxx, dyx;
bool mnwx, anix, trpx, vaxx, vsmx, varx, vfax, vnrx, vbrx, vfrx, vuvx, vtxx, arc=false; // verrou de l'archive
int itexx, itxfx;
// pour la texture noire (0) la texture unie (1) et la texture image (2) 
unsigned char image_nir[256][256][3];
unsigned char image_int[256][256][3];
unsigned char image_img[256*256*3]={0};
COLORREF textColor=4227327;   // couleur bronze 
char texturefilename[MAX_PATH]="\0";
GLuint IdTex[3];
int mult=256;                 // pour la multiplicit de 
bool addup=true, subup=true;  // la texture avec P et M
bool trpr, trpa=false;        // archive de trp et son verrou pour l'affichage des axes
bool sel=false, rfm=false;    // sel=true quand slection et rfm=true quand refermer est possible
bool leftup=true;             // verrou pour la slection ventuelle de la 2-ime arte

void condinit() {  // pour remettre les conditions d'affichage dans l'tat initial
    dist=3.0; zoom=1.0;
    anglex=angley=anglez=dx=dy=0.0;
    ani=trp=vax=vsm=var=vnr=vbr=vfr=vtx=vuv=false; vfa=true;
    itex=itxf=1; 
}

void sauvecond() {  // pour archiver les conditions d'affichage
    distx=dist; zoomx=zoom; xoldx=xold; yoldx=yold;
    anglexx=anglex; angleyx=angley; anglezx=anglez; dxx=dx; dyx=dy;  
    mnwx=mnw; anix=ani; trpx=trp; vaxx=vax; vsmx=vsm; varx=var;
    vfax=vfa; vnrx=vnr; vbrx=vbr; vfrx=vfr; vuvx=vuv; vtxx=vtx;
    itexx=itex; itxfx=itxf;
}

void restaurecond() {  // pour restituer les conditions d'affichage
    dist=distx; zoom=zoomx; xold=xoldx; yold=yoldx;
    anglex=anglexx; angley=angleyx; anglez=anglezx; dx=dxx; dy=dyx; 
    mnw=mnwx; ani=anix; trp=trpx; vax=vaxx; vsm=vsmx; var=varx;
    vfa=vfax; vnr=vnrx; vbr=vbrx; vfr=vfrx; vuv=vuvx; vtx=vtxx;
    itex=itexx; itxf=itxfx;
}

GLvoid TexParameteri() {
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
   return;
}

GLvoid chargeTextureNoir() {  // chargement de la texture noire
   int i,j;
   for (i=0;i<256;i++)
      for (j=0;j<256;j++) {
         image_int[i][j][0]=0;
         image_int[i][j][1]=0; // la texture interne est mise toute noire 
         image_int[i][j][2]=0;
      }
   glBindTexture(GL_TEXTURE_2D, IdTex[0]);
   TexParameteri();
   glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,256,256,0,GL_RGB,GL_UNSIGNED_BYTE,image_nir);
}

GLvoid chargeTextureProc() {    // chargement de la texture interne
   int rcol,gcol,bcol,tcol,i,j;
   bcol=textColor/65536;
   tcol=textColor-65536*bcol;
   gcol=tcol/256;
   rcol=tcol-256*gcol;
   for (i=0;i<256;i++)
      for (j=0;j<256;j++) {
         image_int[i][j][0]=rcol;
         image_int[i][j][1]=gcol; // la texture interne est mise en couleur unie
         image_int[i][j][2]=bcol;
      }
   glBindTexture(GL_TEXTURE_2D, IdTex[1]);
   TexParameteri();
   glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,256,256,0,GL_RGB,GL_UNSIGNED_BYTE,image_int);
}

void loadJpegImage(char *fichier) {  // pour charger une image JPEG 256 x 256 pixels
   struct jpeg_decompress_struct cinfo;
   struct jpeg_error_mgr jerr;
   FILE *file;	
   unsigned char *ligne;
   cinfo.err = jpeg_std_error(&jerr);
   jpeg_create_decompress(&cinfo);
   if((file=fopen(fichier, "rb"))==NULL) quitter("Ouverture impossible de la texture");
   jpeg_stdio_src(&cinfo, file);
   jpeg_read_header(&cinfo, TRUE);
   if((cinfo.image_width!=256)||(cinfo.image_height!=256)) {
      quitter("L'image de texture doit tre de taille 256x256");
   }
   if(cinfo.jpeg_color_space==JCS_GRAYSCALE) quitter("L'image doit tre de type RGB");
   jpeg_start_decompress(&cinfo);
   ligne=image_img;
   while (cinfo.output_scanline < cinfo.output_height) {
      ligne=image_img+3*256*cinfo.output_scanline;
      jpeg_read_scanlines(&cinfo, &ligne, 1);
   }
   jpeg_finish_decompress(&cinfo);
   jpeg_destroy_decompress(&cinfo);
   fclose(file);
   return;
}

void newTextureFile(char *texturefilename) {  // pour choisir le fichier de l'image
   OPENFILENAME ofn;
   ZeroMemory(&ofn, sizeof(OPENFILENAME));
   ofn.lStructSize = sizeof(OPENFILENAME);
   ofn.hwndOwner = hWnd;
   ofn.lpstrFile = texturefilename;
   ofn.nMaxFile = MAX_PATH;
   ofn.lpstrTitle="Choisissez le fichier de nouvelle texture  appliquer.";
   ofn.lpstrFilter = "Jpg Files (*.jpg)\0*.jpg\0\0";
   ofn.nFilterIndex = 1;
   ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
   GetOpenFileName(&ofn);
}

GLvoid chargeTextureFile() {   // chargement d'une nouvelle texture externe
   glDisable(GL_TEXTURE_2D);
   newTextureFile(texturefilename);
   if(strlen(texturefilename)==0) return;
   loadJpegImage(texturefilename);
   glBindTexture(GL_TEXTURE_2D, IdTex[2]);
   TexParameteri();
   glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,256,256,0,GL_RGB,GL_UNSIGNED_BYTE,image_img);
   glEnable(GL_TEXTURE_2D);
   etxt=true;
}

GLvoid initOpenGL() {  // initialisation d'OpenGL
    GLfloat lightloc0[4] = {10.0f, 10.0f, 10.0f, 1.0f};
    GLfloat lightloc1[4] = {-10.0f, 10.0f, 10.0f, 1.0f};
    GLfloat  ambient0[4] = {0.2f, 0.2f, 0.2f, 1.0f};
    GLfloat  diffuse0[4] = {0.5f, 0.5f, 0.5f, 1.0f};
    GLfloat specular0[4] = {0.9f, 0.9f, 0.9f, 1.0f};
    GLfloat  ambient1[4] = {0.2f, 0.2f, 0.2f, 1.0f};
    GLfloat  diffuse1[4] = {0.5f, 0.5f, 0.5f, 1.0f};
    GLfloat specular1[4] = {0.9f, 0.9f, 0.9f, 1.0f};
    GLfloat   ambient[4] = {0.2f, 0.2f, 0.2f, 1.0f};
    GLfloat   diffuse[4] = {0.5f, 0.5f, 0.5f, 1.0f};
    GLfloat  specular[4] = {0.9f, 0.9f, 0.9f, 1.0f};
    GLfloat  emissive[4] = {0.1f, 0.1f, 0.1f, 1.0f};
    GLfloat    shinyness = 128.0f;   // brillance maxi : 128

    /* Initialisation de l'tat d'OpenGL */
//  glClearColor(0.0f, 0.0f, 0.0f, 0.5f);
    glEnable(GL_DEPTH_TEST);
    glAlphaFunc(GL_ALWAYS,0);

    /* Mise en place de la perspective */
    glViewport(0,0,width,height); 
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    gluPerspective(45.0,(GLdouble)width/(GLdouble)height,0.6,20.0);
    glMatrixMode(GL_MODELVIEW);

    /* Paramtres d'clairage */
    glColorMaterial(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE);
    glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, ambient);	
    glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, diffuse);	
    glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, specular);
//  glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, emissive);
    glMaterialf(GL_FRONT_AND_BACK, GL_SHININESS, shinyness);
    glEnable(GL_COLOR_MATERIAL);
    glLightfv(GL_LIGHT0, GL_POSITION, lightloc0);
    glLightfv(GL_LIGHT0, GL_AMBIENT, ambient0);
    glLightfv(GL_LIGHT0, GL_DIFFUSE, diffuse0);
    glLightfv(GL_LIGHT0, GL_SPECULAR, specular0);
    glEnable(GL_LIGHT0);
    glLightfv(GL_LIGHT1, GL_POSITION, lightloc1);  
    glLightfv(GL_LIGHT1, GL_AMBIENT, ambient1);   // la lumire actuelle LIGHT1
    glLightfv(GL_LIGHT1, GL_DIFFUSE, diffuse1);   // n'amliore pas l'affichage
    glLightfv(GL_LIGHT1, GL_SPECULAR, specular1);
//  glEnable(GL_LIGHT1);
    glEnable(GL_NORMALIZE);

    /* Chargement des textures internes */
    glGenTextures(3,IdTex);
    chargeTextureNoir();
    chargeTextureProc();

    /* Mise en place des textures */
    glEnable(GL_TEXTURE_2D);
  
    /*set up basics*/
    glShadeModel(GL_SMOOTH);							
    glClearColor(0.15f, 0.15f, 0.15f, 0.5f); // couleur gris fonc de fond
    glClearDepth(1.0f);									
    glEnable(GL_DEPTH_TEST);							
    glDepthFunc(GL_LEQUAL);								
    glHint(GL_PERSPECTIVE_CORRECTION_HINT,GL_NICEST);
    glEnable(GL_LINE_SMOOTH);
}

GLvoid drawAxes() {
    static double axes=1.0;  // longueur des axes
    glLineWidth(2.0f);       // paisseur de trait pour dessiner les axes
    glPushMatrix();
    glBegin(GL_LINES);
    glColor3d(1.0, 0.0, 0.0);      // Rouge pour l'axe X
    glVertex3d(0.0, 0.0, 0.0);
    glVertex3d(axes, 0.0, 0.0);
    glColor3d(0.0, 1.0 ,0.0);      // Vert pour l'axe Y
    glVertex3d(0.0 ,0.0 ,0.0);
    glVertex3d(0.0, axes, 0.0);
    glColor3d(0.0, 0.0, 1.0);      // Bleu pour l'axe Z
    glVertex3d(0.0, 0.0, 0.0);  
    glVertex3d(0.0, 0.0, axes);
    glEnd();
    glPopMatrix();
    glColor3d(1.0, 1.0, 1.0);
    glLineWidth(0.6f); 
}

GLvoid drawSommets() {
    glColor3d(1.0, 1.0, 1.0);
    glPointSize(4.0f);
    glPushMatrix();
    glBegin(GL_POINTS);
    for(int i=0;i<ns;i++) glVertex3d(xg(i), yg(i), zg(i)); 
    glEnd();
    glPopMatrix();
    glColor3d(1.0, 1.0, 1.0);
    return;
}

GLvoid drawAretes() {
    glColor3d(0.8, 0.8, 0.8);
    glPushMatrix();
    glBegin(GL_LINES);
    for(int i=0;i<nf;i++) {
        glVertex3d(xg(ifa[i]), yg(ifa[i]), zg(ifa[i]));
        glVertex3d(xg(jfa[i]), yg(jfa[i]), zg(jfa[i]));
        glVertex3d(xg(jfa[i]), yg(jfa[i]), zg(jfa[i]));
        glVertex3d(xg(kfa[i]), yg(kfa[i]), zg(kfa[i]));
        glVertex3d(xg(kfa[i]), yg(kfa[i]), zg(kfa[i]));
        glVertex3d(xg(ifa[i]), yg(ifa[i]), zg(ifa[i]));
    }
    glEnd();
    glPopMatrix();
    glColor3d(1.0, 1.0, 1.0);
}

void mat44(double m44[4][4] ,GLdouble m[16]) {  // conversion de matrice en 4x4
    int i,j,k;
    k=0;                  
    for (i=0;i<4;i++)
        for (j=0;j<4;j++) {
            m44[i][j] = m[k];
            k++;
       }
}     

void mulvec44(double q[4], double a[4][4], double p[4]) {  // q = a x p  en dimension 4 
    int i,j;
    for (i=0;i<4;i++) {   
        q[i] = 0.0;
        for (j=0;j<4;j++) q[i] = q[i] + a[i][j] * p[j]; 
    }
}

GLvoid drawFaces() {
    int i;
    GLdouble modelview[16];
    double modelview44[4][4];
    double v0[4], v1[4], p1[3], p2[3], p3[3], vn[3], nv;
    double fois, up, vp;
    fois=((double)mult)/256.0;
    glColor3d(0.8, 0.8, 0.8);    
    glDisable(GL_TEXTURE_2D);
    glEnable(GL_LIGHTING);
    glAlphaFunc(GL_NEVER,0);
    if(itex!=2 || epuv) glEnable(GL_TEXTURE_2D);
    if(trp) {                 // si transparence
        glDepthMask(GL_FALSE);
        glEnable(GL_BLEND);
        glBlendFunc(GL_SRC_ALPHA, GL_ONE);
        glColor4d(0.5, 0.5, 0.5, 0.5);
    }
    glPushMatrix();
    glGetDoublev(GL_MODELVIEW_MATRIX, modelview);
    mat44(modelview44,modelview);      // passage de [16]  [4][4]
    v1[0]=0.0; v1[1]=0.0; v1[2]=1.0; v1[3]=1.0;
    mulvec44(v0,modelview44,v1);       // direction actuelle de l'oeuil de l'observateur
    for(i=0;i<nf;i++) {
        p1[0]=xg(ifa[i]); p1[1]=yg(ifa[i]); p1[2]=zg(ifa[i]);           // les
        p2[0]=xg(jfa[i]); p2[1]=yg(jfa[i]); p2[2]=zg(jfa[i]);           // sommets
        p3[0]=xg(kfa[i]); p3[1]=yg(kfa[i]); p3[2]=zg(kfa[i]);           // du triangle
        vn[0]=(p2[1]-p1[1])*(p3[2]-p1[2])-(p3[1]-p1[1])*(p2[2]-p1[2]);  // et une
        vn[1]=(p2[2]-p1[2])*(p3[0]-p1[0])-(p3[2]-p1[2])*(p2[0]-p1[0]);  // normale
        vn[2]=(p2[0]-p1[0])*(p3[1]-p1[1])-(p3[0]-p1[0])*(p2[1]-p1[1]);  // dirige
        if((v0[0]*vn[0]+v0[1]*vn[1]+v0[2]*vn[2]) < 0.0) {               // vers
            vn[0]=-vn[0]; vn[1]=-vn[1]; vn[2]=-vn[2];                   // l'observateur
        }
        nv = sqrt(vn[0]*vn[0]+vn[1]*vn[1]+vn[2]*vn[2]);
        for(int j=0;j<3;j++) vn[j]=vn[j]/nv;    // vecteur normal unitaire de cette face
        glBegin(GL_POLYGON);
        glNormal3d(vn[0], vn[1], vn[2]);
        if(itex==2 && etxt && epuv) {      // modle textur avec une image
        // les us[] et vs[] de [-1,-1]  [+1,+1] sont utiliss de [0,0]  [1,1]
            up=fois*(1.0+us[ifa[i]])/2.0; vp=fois*(1.0+vs[ifa[i]])/2.0;
            glTexCoord2d(up, vp);
            glVertex3d(p1[0], p1[1], p1[2]);
            up=fois*(1.0+us[jfa[i]])/2.0; vp=fois*(1.0+vs[jfa[i]])/2.0;
            glTexCoord2d(up, vp);
            glVertex3d(p2[0], p2[1], p2[2]);
            up=fois*(1.0+us[kfa[i]])/2.0; vp=fois*(1.0+vs[kfa[i]])/2.0;
            glTexCoord2d(up, vp);
            glVertex3d(p3[0], p3[1], p3[2]);
        }
        else {
            if(itex==2 && !etxt) {   // affichage en blanc
                glVertex3d(p1[0], p1[1], p1[2]);
                glVertex3d(p2[0], p2[1], p2[2]);
                glVertex3d(p3[0], p3[1], p3[2]);
            }
            else {                                   // pour itex = 0 ou 1
                glTexCoord2d(0.0, 0.0);   
                glVertex3d(p1[0], p1[1], p1[2]);     // pour : itex=2 avec etxt et !epuv 
                glTexCoord2d(1.0*fois, 0.0);         // ceci est excut aussi mais en blanc car
                glVertex3d(p2[0], p2[1], p2[2]);     // glEnable(GL_TEXTURE_2D);  est non activ 
                glTexCoord2d(1.0*fois, 1.0*fois);                     
                glVertex3d(p3[0], p3[1], p3[2]);
            }
        }
        glEnd();
    }   
    glPopMatrix();
    if(trp) {
        glColor4d(1.0,1.0,1.0,1.0);
        glDisable(GL_BLEND);
        glDepthMask(GL_TRUE);
    }
    if(itex!=2 || epuv) glDisable(GL_TEXTURE_2D);
    glAlphaFunc(GL_ALWAYS,0);
    glDisable(GL_LIGHTING);
    glColor3d(1.0, 1.0, 1.0);
}

GLvoid drawNormales() {
    int i, j;
    double p1[3], p2[3], p3[3], vn[3], nv, cg[3];
    glColor3d(0.0, 1.0, 0.0);
    glPushMatrix();
    for(i=0;i<nf;i++) {
        p1[0]=xg(ifa[i]); p1[1]=yg(ifa[i]); p1[2]=zg(ifa[i]);
        p2[0]=xg(jfa[i]); p2[1]=yg(jfa[i]); p2[2]=zg(jfa[i]);
        p3[0]=xg(kfa[i]); p3[1]=yg(kfa[i]); p3[2]=zg(kfa[i]);
        vn[0]=(p2[1]-p1[1])*(p3[2]-p1[2])-(p3[1]-p1[1])*(p2[2]-p1[2]);
        vn[1]=(p2[2]-p1[2])*(p3[0]-p1[0])-(p3[2]-p1[2])*(p2[0]-p1[0]);
        vn[2]=(p2[0]-p1[0])*(p3[1]-p1[1])-(p3[0]-p1[0])*(p2[1]-p1[1]);
        nv = sqrt(vn[0]*vn[0]+vn[1]*vn[1]+vn[2]*vn[2]);
        for(j=0;j<3;j++) vn[j]=vn[j]/nv;
        for(j=0;j<3;j++) cg[j]=(p1[j]+p2[j]+p3[j])/3.0;
        glBegin(GL_LINES);
        nv=0.2*zoom;
        glVertex3d(cg[0]-nv*vn[0], cg[1]-nv*vn[1], cg[2]-nv*vn[2]);
        glVertex3d(cg[0]+nv*vn[0], cg[1]+nv*vn[1], cg[2]+nv*vn[2]);
        glEnd();
    }   
    glPopMatrix();
    glColor3d(1.0, 1.0, 1.0);
}

void drawBords() {
    int i;
    glPushMatrix();
    glColor3d(1.0, 0.0, 0.0);
    glBegin(GL_LINES);
    for(i=0; i<naf; i++) {
        glVertex3d(xg(iar[i]), yg(iar[i]), zg(iar[i]));
        glVertex3d(xg(jar[i]), yg(jar[i]), zg(jar[i]));
        glVertex3d(xg(jar[i]), yg(jar[i]), zg(jar[i]));
        glVertex3d(xg(iar[i]), yg(iar[i]), zg(iar[i]));
    }
    glEnd();
    glColor3d(0.0, 1.0, 0.0);
    glBegin(GL_LINES);
    for(i=naf; i<nab; i++) {
        glVertex3d(xg(iar[i]), yg(iar[i]), zg(iar[i]));
        glVertex3d(xg(jar[i]), yg(jar[i]), zg(jar[i]));
        glVertex3d(xg(jar[i]), yg(jar[i]), zg(jar[i]));
        glVertex3d(xg(iar[i]), yg(iar[i]), zg(iar[i]));
    }
    glEnd();
    glPopMatrix();
    glColor3d(1.0, 1.0, 1.0);
}

GLvoid drawFront() {
    glColor3d(1.0, 0.0, 0.0);  
    glLineWidth(2.0f);
    glPushMatrix();
    glBegin(GL_LINES);
    for(int i=0;i<naf;i++) {
        glVertex3d(xg(iar[i]), yg(iar[i]), zg(iar[i]));
        glVertex3d(xg(jar[i]), yg(jar[i]), zg(jar[i]));
    }
    glEnd();
    glPopMatrix();
    glLineWidth(0.6f);
    glColor3d(1.0, 1.0, 1.0);
}

GLvoid drawPlanuv() {
    if(!arc) {
        sauvecond();
        arc=true;
    }
    condinit();
    vuv=true;
    mnw=false;
    itex=0;
    glBindTexture(GL_TEXTURE_2D, IdTex[itex]);
    glEnable(GL_LIGHTING);
    glAlphaFunc(GL_NEVER,0);  
    glEnable(GL_TEXTURE_2D);
    glPushMatrix();
    glBegin(GL_POLYGON);  // pour un ventuel fond noir du plan (u,v)
/*
    glNormal3d(0.0, 0.0, 1.0);    // le plan (u,v) affich
    glVertex3d(-1.0, -1.0, 0.0);  // est le carr qui va de
    glVertex3d(1.0, -1.0, 0.0);   // (-1,-1 )  (1,1) et non
    glVertex3d(1.0, 1.0, 0.0);    // pas le carr des textures
    glVertex3d(-1.0, 1.0, 0.0);   // qui va de (0,0)  (1,1)
*/
    glEnd();
    glPopMatrix();
    glDisable(GL_TEXTURE_2D);
    glAlphaFunc(GL_ALWAYS,0);
    glDisable(GL_LIGHTING);
    glColor3d(0.8, 0.8, 0.8);    
    glPushMatrix();
    glBegin(GL_LINES);
    for(int i=0;i<na;i++) {
        glVertex3d(us[iar[i]], vs[iar[i]], 0.0);
        glVertex3d(us[jar[i]], vs[jar[i]], 0.0);
        glVertex3d(us[jar[i]], vs[jar[i]], 0.0);
        glVertex3d(us[iar[i]], vs[iar[i]], 0.0);
    }
    glEnd();
    glPopMatrix();
    glColor3d(1.0, 1.0, 1.0);
}

GLvoid drawTexture() {
    double fois;
    fois=((double)mult)/256.0;
    if(!arc) {
        sauvecond();
        arc=true;
    }
    condinit();
    vtx=true;
    mnw=false;
    itex=2;
    glEnable(GL_LIGHTING);
    glAlphaFunc(GL_NEVER,0);  
    glEnable(GL_TEXTURE_2D);
    glPushMatrix();
    glBegin(GL_POLYGON);
    glNormal3d(0.0, 0.0, 1.0);
    glTexCoord2d(0.0, fois);                     
    glVertex3d(-1.0, -1.0, 0.0);
    glTexCoord2d(fois, fois);                     
    glVertex3d(1.0, -1.0, 0.0);
    glTexCoord2d(fois, 0.0);   
    glVertex3d(1.0, 1.0, 0.0);
    glTexCoord2d(0.0, 0.0);   
    glVertex3d(-1.0, 1.0, 0.0);
    glEnd();
    glPopMatrix();
    glDisable(GL_TEXTURE_2D);
    glAlphaFunc(GL_ALWAYS,0);
    glDisable(GL_LIGHTING);
}

GLvoid GetOGLPos(GLdouble ptv[3]) {  // pt : point vis
    GLint viewport[4];
    POINT mouse;			
    GLdouble projmat[16], modelvue[16];
    double winX, winY, winZ;
    float data;
    glGetIntegerv(GL_VIEWPORT, viewport);	
    GetCursorPos(&mouse);	
    ScreenToClient(hWnd, &mouse);
    glGetDoublev(GL_MODELVIEW_MATRIX, modelvue);
    glGetDoublev(GL_PROJECTION_MATRIX, projmat);
    winX = (double)mouse.x;				
    winY = (double)mouse.y;					
    winY = (double)viewport[3] - winY;	
    glReadPixels((GLint)winX, (GLint)winY, 1, 1, GL_DEPTH_COMPONENT, GL_FLOAT, &data);
    winZ = (double)data;
    gluUnProject(winX, winY, winZ, modelvue, projmat, viewport, &ptv[0], &ptv[1], &ptv[2]);
}

void mouse() {  
    POINT pt;
    RECT rect;
    const SHORT Mask = (SHORT)32768;
    double x1,x2,y1,y2,xnew,ynew;     
    GetWindowRect (hWnd, &rect);
    x1=(double)rect.left;
    x2=(double)rect.right;
    y1=(double)rect.top;
    y2=(double)rect.bottom;
    GetCursorPos(&pt);
    SetCursorPos(pt.x,pt.y);
    xnew = (double)pt.x;
    ynew = (double)pt.y;
    if(xnew < x1+10.0) mnw=false;  // en largeur
    if(xnew > x2-10.0) mnw=false;
    if(ynew < y1+50.0) mnw=false;  // en hauteur
    if(ynew > y2-35.0) mnw=false;
    if(mnw && !sel) {
        if(GetKeyState(VK_LBUTTON) & Mask) {
            anglex = anglex + (xnew-xold)/1.5;
            angley = angley + (ynew-yold)/1.5;
        }
        if(GetKeyState(VK_RBUTTON) & Mask) {
            angley = angley + (ynew-yold)/1.5;
            anglez = anglez + (xnew-xold)/1.5;
        }
    }
    xold = xnew;
    yold = ynew;
    mnw = true;
    if(sel) {
        if(leftup && (GetKeyState(VK_LBUTTON) & Mask)) {
            leftup=false;
            decouper();
            rfm=true;
        }
        if(!(GetKeyState(VK_LBUTTON) & Mask)) leftup=true;
    }
    if(rfm) {
        if(GetKeyState(VK_RETURN) & Mask) {
            refermer();
            rfm=false;
        }
    }
}

GLvoid vue() {  // mise  jour de la vue active
    const SHORT Mask = (SHORT)32768;
    mouse();             
    glBindTexture(GL_TEXTURE_2D, IdTex[itex]);  // avec la texture active
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    glTranslated(0.0,0.0,-2.5);	
    glLoadIdentity();
    glTranslated(dx,dy,0.0);	   // translation dans la fentre
    glMatrixMode(GL_MODELVIEW);
    gluLookAt(dx,dy,dist,0.0,0.0,0.0,0.0,1.0,0.0);
    if(ani) {
        anglex=anglex+0.13;
        angley=angley+0.21;
        anglez=anglez+0.30;
    }
    glRotated(anglex,0.0,1.0,0.0);
    glRotated(angley,1.0,0.0,0.0);  // rotation 3D du modle
    glRotated(anglez,0.0,0.0,1.0);
    if(GetKeyState(VK_UP) & Mask) {
        dist = dist*0.99;
        if(dist<1.5) dist=1.5;
    }
    if(GetKeyState(VK_DOWN) & Mask) {
        dist = dist*1.01;
        if(dist>15.0) dist=15.0;
    }
    if(GetKeyState(VK_LEFT) & Mask) {
        zoom = zoom*0.99;
        if(zoom<0.1)zoom=0.1;
    }
    if(GetKeyState(VK_RIGHT) & Mask) {
        zoom = zoom*1.01;
        if(zoom>10.0)zoom=10.0;
    }
    if(itex==2) {
        if(addup && (GetKeyState(80) & Mask)) {  // P
            addup=false;
            mult = mult*2;
            if(mult>2048) mult=2048;
        }  
        if(!(GetKeyState(80) & Mask)) addup=true;
        if(subup && (GetKeyState(77) & Mask)) {  // M
            subup=false;
            mult = mult/2;
            if(mult<64) mult=64;
        }
        if(!(GetKeyState(77) & Mask)) subup=true;
    }
    if(GetKeyState(67) & Mask) dx=dx+0.01;  // C
    if(GetKeyState(68) & Mask) dy=dy+0.01;  // D
    if(GetKeyState(83) & Mask) dy=dy+0.01;  // S
    if(GetKeyState(87) & Mask) dx=dx-0.01;  // W
    if(GetKeyState(88) & Mask) dy=dy-0.01;  // X
}

void selectSommet() {
    int i;
    double pt[3], vt[3], dd, dm;
    GetOGLPos(pt);           // pt : le point sous la souris
    vt[0]=xg(0)-pt[0]; vt[1]=yg(0)-pt[1]; vt[2]=zg(0)-pt[2]; 
    dm=sqrt(vt[0]*vt[0]+vt[1]*vt[1]+vt[2]*vt[2]);
    isel=0;
    for(i=1; i<ns; i++) {     // isel : le sommet le plus proche 
        vt[0]=xg(i)-pt[0]; vt[1]=yg(i)-pt[1]; vt[2]=zg(i)-pt[2]; 
        dd=sqrt(vt[0]*vt[0]+vt[1]*vt[1]+vt[2]*vt[2]);
        if(dd<dm){dm=dd; isel=i;}
    }
    glColor3d(1.0, 0.0, 0.0);
    glPushMatrix();
    glBegin(GL_POINTS);
    glVertex3d(xg(isel), yg(isel), zg(isel)); 
    glEnd();
    glPopMatrix();
    glColor3d(1.0, 1.0, 1.0);
}

void voirBords() {
    drawBords();
    SwapBuffers(g_hdc);
    Sleep(250);
}

void selectArete() {
    int i;
    double pt[3], cg[3], vt[3], dd, dm;
    GetOGLPos(pt);
    dm=10000.0;
    isel=0;
    for(i=0; i<na; i++) {
        cg[0]=(xg(iar[i])+xg(jar[i]))/2.0;
        cg[1]=(yg(iar[i])+yg(jar[i]))/2.0;
        cg[2]=(zg(iar[i])+zg(jar[i]))/2.0;
        vt[0]=cg[0]-pt[0]; vt[1]=cg[1]-pt[1]; vt[2]=cg[2]-pt[2]; 
        dd=sqrt(vt[0]*vt[0]+vt[1]*vt[1]+vt[2]*vt[2]);
        if(dd<dm){dm=dd; isel=i;}
    }
    glPushMatrix();
    glColor3d(1.0, 0.0, 0.0);
    glBegin(GL_LINES);
    glVertex3d(xg(iar[isel]), yg(iar[isel]), zg(iar[isel]));
    glVertex3d(xg(jar[isel]), yg(jar[isel]), zg(jar[isel]));
    glVertex3d(xg(jar[isel]), yg(jar[isel]), zg(jar[isel]));
    glVertex3d(xg(iar[isel]), yg(iar[isel]), zg(iar[isel]));
    glEnd();
    drawBords();
    glColor3d(1.0, 1.0, 1.0);
}

void selectFace() {
    int i;
    double pt[3], cg[3], vt[3], dd, dm;
    GetOGLPos(pt);
    dm=10000.0;
    isel=0;
    for(i=0; i<nf; i++) {
        cg[0]=(xg(ifa[i])+xg(jfa[i])+xg(kfa[i]))/3.0;
        cg[1]=(yg(ifa[i])+yg(jfa[i])+yg(kfa[i]))/3.0;
        cg[2]=(zg(ifa[i])+zg(jfa[i])+zg(kfa[i]))/3.0;
        vt[0]=cg[0]-pt[0]; vt[1]=cg[1]-pt[1]; vt[2]=cg[2]-pt[2]; 
        dd=sqrt(vt[0]*vt[0]+vt[1]*vt[1]+vt[2]*vt[2]);
        if(dd<dm){dm=dd; isel=i;}
    }
    glColor3d(1.0, 0.0, 0.0);
    glPushMatrix();
    glBegin(GL_LINES);
    glVertex3d(xg(ifa[isel]), yg(ifa[isel]), zg(ifa[isel]));
    glVertex3d(xg(jfa[isel]), yg(jfa[isel]), zg(jfa[isel]));
    glVertex3d(xg(jfa[isel]), yg(jfa[isel]), zg(jfa[isel]));
    glVertex3d(xg(kfa[isel]), yg(kfa[isel]), zg(kfa[isel]));
    glVertex3d(xg(kfa[isel]), yg(kfa[isel]), zg(kfa[isel]));
    glVertex3d(xg(ifa[isel]), yg(ifa[isel]), zg(ifa[isel]));
    glEnd();
    glPopMatrix();
    glColor3d(1.0, 1.0, 1.0);
}

GLvoid displayGL() {
    vue();
    if(vuv) drawPlanuv();
    if(vtx) drawTexture();
    if(!vuv & !vtx) drawFaces();
    if(vax) drawAxes();
    if(vsm) drawSommets();
    if(var) drawAretes();
    if(vnr) drawNormales();
    if(vbr) drawBords();
    if(vfr) drawFront();
    if(!trpa&vax&!vsm&!var&!vnr&!vbr&!vfr&!vfa) {
        trpr=trp;  // on sauvegarde trp
        trp=true;  // si uniquement affichage des axes
        trpa=true; // trpa : verrou pour trpr
    }
    if(trpa&(!vax||vsm||var||vnr||vbr||vfr||vfa)) {
        trp=trpr;
        trpa=false;
    }
    if(sel) {
        if(csm) selectSommet();
        if(car) selectArete();
        if(cfa) selectFace();
    }
}
