// utils.cpp

#include "utils.h"

void allocint(int **list, int n) {  // pour faire alloc
    int i;                          // d'un tableau de int
    *list = new int[n];
    for(i=0;i<n;i++) (*list)[i]=0;
}
void allocfloat(float **list, int n) {  // pour faire alloc
    int i;                              // d'un tableau de float
    *list = new float[n];
    for(i=0;i<n;i++) (*list)[i]=0.0f;
}
void allocdouble(double **list, int n) {  // pour faire alloc
    int i;                                // d'un tableau de float
    *list = new double[n];
    for(i=0;i<n;i++) (*list)[i]=0.0f;
}
void reallocint(int **list, int ni, int nn) {  // pour faire realloc
    int *nouv, i;                              // d'un tableau de int
    nouv = new int[nn];
    for(i=0;i<ni;i++) nouv[i] = (*list)[i];
    for(i=ni;i<nn;i++) nouv[i] = 0;
    delete [] *list;
    *list = new int[nn];
    for(i=0;i<nn;i++) (*list)[i]=nouv[i];
    delete [] nouv;
}
void reallocfloat(float **list, int ni, int nn) {  // pour faire realloc
    float *nouv;                                   // d'un tableau de float
    int i;
    nouv = new float[nn];
    for(i=0;i<ni;i++) nouv[i] = (*list)[i];
    for(i=ni;i<nn;i++) nouv[i] = 0.0f;
    delete [] *list;
    *list = new float[nn];
    for(i=0;i<nn;i++) (*list)[i]=nouv[i];
    delete [] nouv;
}
void reallocdouble(double **list, int ni, int nn) {  // pour faire realloc
    double *nouv;                                    // d'un tableau de double
    int i;
    nouv = new double[nn];
    for(i=0;i<ni;i++) nouv[i] = (*list)[i];
    for(i=ni;i<nn;i++) nouv[i] = 0.0;
    delete [] *list;
    *list = new double[nn];
    for(i=0;i<nn;i++) (*list)[i]=nouv[i];
    delete [] nouv;
}
void xint(int *i, int *j) {  // pour changer deux variables int
   int k;
   k=*i;
   *i=*j;    
   *j=k;
}
void xfloat(float *x, float *y) {  // pour changer deux variables float
   float z;
   z=*x;
   *x=*y;    
   *y=z;
}
void xdouble(double *x, double *y) {  // pour changer deux variables double
   double z;
   z=*x;
   *x=*y;    
   *y=z;
}
void jordan(double **a, double *b, int n) {   // solution de Ax=b
    double p;
    int i,j,k;
    for(k=0; k<n; k++) {
        if (a[k][k]==0.0) quitter("La mthode de Jordan est en dfaut.");
        p=a[k][k];
        for (j=k; j<n; j++) a[k][j]=a[k][j]/p;
        b[k]=b[k]/p;
        for(i=0; i<n; i++) {
            if (i!=k) {
                p=a[i][k];                
                for (j=k; j<n; j++) a[i][j]=a[i][j]-p*a[k][j];
                b[i]=b[i]-p*b[k];
            }
        }
    }
}
double dist2p(double p1[3], double p2[3]) {
    double dx, dy, dz;
    dx=p2[0]-p1[0];
    dy=p2[1]-p1[1];        // distance entre 2 points
    dz=p2[2]-p1[2];
    return sqrt(dx*dx+dy*dy+dz*dz);
}
double surftri(double p1[3], double p2[3], double p3[3]) {  
    double p, a, b, c;
    a=dist2p(p2,p3);
    b=dist2p(p3,p1);         // surface d'un triangle
    c=dist2p(p1,p2);
    p=(a+b+c)/2.0;
    return sqrt(p*(p-a)*(p-b)*(p-c));
}
double angletri(double p1[3], double p2[3], double p3[3]) {  
    double a, b, c, cosa;
    a=dist2p(p2,p3);
    b=dist2p(p3,p1);         // angle (p1p2,p1p3)
    c=dist2p(p1,p2);
    cosa=(b*b+c*c-a*a)/(2.0*b*c);
    return acos(cosa);
}
